unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_PBRklist, U_PBCKlist, U_PBKcList, dxCore, activex;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmPBRklistQB, frmPBRklistQBGQX: TfrmPBRklist;
  frmPBCKlistQB, frmPBCKlistQBGQX: TfrmPBCKlist;
  frmPBKcListQB: TfrmPBKcList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '121.37.171.80,7781';
//  server := '.';
  dtbase := 'manfengdata';
  user := 'manfengsa';
  pswd := 'rightsoft@8811';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
//  DConString := DataBaseStr;
//  DParameters1 := '高权限';

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //坯布汇总入库
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布汇总入库' then
          begin
            BringWindowToTop(frmPBRklistQB.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBRklistQB := TfrmPBRklist.Create(application.MainForm);
          with frmPBRklistQB do
          begin
            Title := '坯布汇总入库';
            FZZType := '全部';
            canshu1 := '录入';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBRklistQB.BringToFront;
       //句柄
        mnewHandle := frmPBRklistQB.Handle;
      end;
    112:  //坯布汇总入库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布汇总入库管理' then
          begin
            BringWindowToTop(frmPBRklistQBGQX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBRklistQBGQX := TfrmPBRklist.Create(application.MainForm);
          with frmPBRklistQBGQX do
          begin
            Title := '坯布汇总入库管理';
            FZZType := '全部';
            canshu1 := '高权限';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBRklistQBGQX.BringToFront;
       //句柄
        mnewHandle := frmPBRklistQBGQX.Handle;
      end;
    121:  //坯布汇总出库
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布汇总出库' then
          begin
            BringWindowToTop(frmPBCKlistQB.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBCKlistQB := TfrmPBCKlist.Create(application.MainForm);
          with frmPBCKlistQB do
          begin
            Title := '坯布汇总出库';
            FZZType := '全部';
            canshu1 := '录入';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBCKlistQB.BringToFront;
       //句柄
        mnewHandle := frmPBCKlistQB.Handle;
      end;
    122:  //坯布汇总出库
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布汇总出库' then
          begin
            BringWindowToTop(frmPBCKlistQBGQX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBCKlistQBGQX := TfrmPBCKlist.Create(application.MainForm);
          with frmPBCKlistQBGQX do
          begin
            Title := '坯布汇总出库管理';
            FZZType := '全部';
            canshu1 := '高权限';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBCKlistQBGQX.BringToFront;
       //句柄
        mnewHandle := frmPBCKlistQBGQX.Handle;
      end;

    131:  //坯布汇总库存
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '坯布汇总库存' then
          begin
            BringWindowToTop(frmPBKcListQB.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmPBKcListQB := TfrmPBKcList.Create(application.MainForm);
          with frmPBKcListQB do
          begin
            Title := '坯布汇总库存';
            FZZType := '全部';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBKcListQB.BringToFront;
       //句柄
        mnewHandle := frmPBKcListQB.Handle;
      end;

  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_ClothWarehouse) then
    DataLink_ClothWarehouse := TDataLink_ClothWarehouse.Create(Application);
  try
    with DataLink_ClothWarehouse.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_ClothWarehouse.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;
//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_ClothWarehouse.Free;
//  Application := OldDllApp;

end.

